Class | Erubis::TinyEruby
In: | erubis/tiny.rb
Parent: | Object

tiny and the simplest implementation of eRuby

ex.

      eruby = TinyEruby.new(File.read('example.rhtml'))
      print eruby.src                 # print ruby code
      print eruby.result(binding())   # eval ruby code with Binding object
      print eruby.evalute(context)    # eval ruby code with context object

### Methods

convert evaluate new result

### Constants

EMBEDDED_PATTERN | = | /<%(=+|\#)?(.*?)-?%>/m

### Attributes

src | [R] |

### Public Class methods

new(input=nil)

[Source]

    # File erubis/tiny.rb, line 20
        def initialize(input=nil)
          @src = convert(input) if input
        end

### Public Instance methods

convert(input)

[Source]

    # File erubis/tiny.rb, line 27
        def convert(input)
          src = "_buf = '';"           # preamble
          pos = 0
          input.scan(EMBEDDED_PATTERN) do |indicator, code|
            match = Regexp.last_match
            len   = match.begin(0) - pos
            text  = input[pos, len]
            pos   = match.end(0)
            #src << " _buf << '" << escape_text(text) << "';"
            text.gsub!(/['\\]/, '\\\\\&')
            src << " _buf << '" << text << "';" unless text.empty?
            if !indicator              # <% %>
              src << code << ";"
            elsif indicator == '#'     # <%# %>
              src << ("\n" * code.count("\n"))
            else                       # <%= %>
              src << " _buf << (" << code << ").to_s;"
            end
          end
          #rest = $' || input                        # ruby1.8
          rest = pos == 0 ? input : input[pos..-1]   # ruby1.9
          #src << " _buf << '" << escape_text(rest) << "';"
          rest.gsub!(/['\\]/, '\\\\\&')
          src << " _buf << '" << rest << "';" unless rest.empty?
          src << "\n_buf.to_s\n"       # postamble
          return src
        end

evaluate(_context=Object.new)

[Source]

    # File erubis/tiny.rb, line 63
        def evaluate(_context=Object.new)
          if _context.is_a?(Hash)
            _obj = Object.new
            _context.each do |k, v| _obj.instance_variable_set("@#{k}", v) end
            _context = _obj
          end
          _context.instance_eval @src
        end

result(_binding=TOPLEVEL_BINDING)

def escape_text(text)

      return text.gsub!(/['\\]/, '\\\\\&') || text

end

[Source]

    # File erubis/tiny.rb, line 59
        def result(_binding=TOPLEVEL_BINDING)
          eval @src, _binding
        end

[Validate]